ALTER TABLE space ADD NEED_INDEXING tinyint(1) default '0' AFTER BASE_URL;

ALTER TABLE licence_type ADD ATTACHMENT_NUM_LIMIT int(11) NOT NULL default 0 AFTER ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence_type ADD WIKI_ATTACHMENT_NUM_LIMIT int(11) NOT NULL default 0 AFTER WIKI_ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence_type ADD FILE_SHARING tinyint(1) NOT NULL default 0 AFTER WIKI_ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence_type ADD SUBVERSION tinyint(1) NOT NULL default 0 AFTER FILE_SHARING;
ALTER TABLE licence_type ADD STORAGE_LIMIT bigint(20) NOT NULL default 0 AFTER SUBVERSION;
ALTER TABLE licence_type ADD SUBVERSION_EXTERNAL tinyint(1) NOT NULL default 0 AFTER SUBVERSION;

ALTER TABLE licence ADD ATTACHMENT_NUM_LIMIT int(11) NOT NULL default 0 AFTER ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence ADD WIKI_ATTACHMENT_NUM_LIMIT int(11) NOT NULL default 0 AFTER WIKI_ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence ADD FILE_SHARING tinyint(1) NOT NULL default 0 AFTER WIKI_ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence ADD SUBVERSION tinyint(1) NOT NULL default 0 AFTER FILE_SHARING;
ALTER TABLE licence ADD STORAGE_LIMIT bigint(20) NOT NULL default 0 AFTER SUBVERSION;
ALTER TABLE licence ADD SUBVERSION_EXTERNAL tinyint(1) NOT NULL default 0 AFTER SUBVERSION;


ALTER TABLE licence_changelog ADD ATTACHMENT_NUM_LIMIT int(11) NOT NULL default 0 AFTER ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence_changelog ADD WIKI_ATTACHMENT_NUM_LIMIT int(11) NOT NULL default 0 AFTER WIKI_ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence_changelog ADD FILE_SHARING tinyint(1) NOT NULL default 0 AFTER WIKI_ATTACHMENT_LIMIT_PER_FILE;
ALTER TABLE licence_changelog ADD SUBVERSION tinyint(1) NOT NULL default 0 AFTER FILE_SHARING;
ALTER TABLE licence_changelog ADD STORAGE_LIMIT bigint(20) NOT NULL default 0 AFTER SUBVERSION;
ALTER TABLE licence_changelog ADD SUBVERSION_EXTERNAL tinyint(1) NOT NULL default 0 AFTER SUBVERSION;

ALTER TABLE users ADD DISABLED int(11) NOT NULL DEFAULT 0 AFTER LAST_LOGIN_TIME;
ALTER TABLE users DROP KEY `UQ_SPACE_ID_USER_ID`;
ALTER TABLE users ADD UNIQUE KEY `UQ_SPACE_ID_USER_ID` (SPACE_ID, USER_ID, DISABLED);

CREATE TABLE dashboard (
  USER_ID int(11) NOT NULL default '0',
  SHOW_CREATED_ISSUE tinyint(1) default NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (USER_ID),
  KEY USER_ID (USER_ID),
  CONSTRAINT FK_dashboard_USER_ID FOREIGN KEY (USER_ID) REFERENCES users (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE project ADD ARCHIVED tinyint(1) NOT NULL default '0' AFTER DISPLAY_ORDER;

CREATE TABLE default_issue_type (
  ID int(11) NOT NULL default '0',
  NAME varchar(20) NOT NULL,
  DISPLAY_ORDER int(11) NOT NULL,
  COLOR varchar(20) NOT NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE issue_type;
CREATE TABLE issue_type (
  ID int(11) NOT NULL auto_increment,
  PROJECT_ID int(11) NOT NULL,
  NAME varchar(20) NOT NULL default '',
  DISPLAY_ORDER int(11) default NULL,
  COLOR varchar(20) NOT NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (ID),
  KEY IX_PROJECT_ID (PROJECT_ID),
  CONSTRAINT FK_issue_type_PROJECT_ID FOREIGN KEY (PROJECT_ID) REFERENCES project (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE `issue_component` (
  `ISSUE_ID` int(11) NOT NULL,
  `LINK_ID` int(11) NOT NULL,
  `CREATED_USER_ID` int(11) default NULL,
  `CREATED` datetime default NULL,
  `UPDATED_USER_ID` int(11) default NULL,
  `UPDATED` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY (`ISSUE_ID`,`LINK_ID`),
  KEY `ISSUE_ID` (`ISSUE_ID`),
  KEY `LINK_ID` (`LINK_ID`),
  CONSTRAINT `FK_issue_component_1` FOREIGN KEY (`ISSUE_ID`) REFERENCES `issue` (`ID`) ON DELETE CASCADE,
  CONSTRAINT `FK_issue_component_2` FOREIGN KEY (`LINK_ID`) REFERENCES `component` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `issue_affectedversion` (
  `ISSUE_ID` int(11) NOT NULL,
  `LINK_ID` int(11) NOT NULL,
  `CREATED_USER_ID` int(11) default NULL,
  `CREATED` datetime default NULL,
  `UPDATED_USER_ID` int(11) default NULL,
  `UPDATED` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY (`ISSUE_ID`,`LINK_ID`),
  KEY `ISSUE_ID` (`ISSUE_ID`),
  KEY `LINK_ID` (`LINK_ID`),
  CONSTRAINT `FK_issue_affectedversion_1` FOREIGN KEY (`ISSUE_ID`) REFERENCES `issue` (`ID`) ON DELETE CASCADE,
  CONSTRAINT `FK_issue_affectedversion_2` FOREIGN KEY (`LINK_ID`) REFERENCES `version` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `issue_fixedversion` (
  `ISSUE_ID` int(11) NOT NULL,
  `LINK_ID` int(11) NOT NULL,
  `CREATED_USER_ID` int(11) default NULL,
  `CREATED` datetime default NULL,
  `UPDATED_USER_ID` int(11) default NULL,
  `UPDATED` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY (`ISSUE_ID`,`LINK_ID`),
  KEY `ISSUE_ID` (`ISSUE_ID`),
  KEY `LINK_ID` (`LINK_ID`),
  CONSTRAINT `FK_issue_fixedversion_1` FOREIGN KEY (`ISSUE_ID`) REFERENCES `issue` (`ID`) ON DELETE CASCADE,
  CONSTRAINT `FK_issue_fixedversion_2` FOREIGN KEY (`LINK_ID`) REFERENCES `version` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE project_mail ADD SUBVERSION tinyint(1) AFTER SUMMARY;
ALTER TABLE project_mail ADD ALL_ISSUE tinyint(1) default NULL AFTER SUMMARY;
ALTER TABLE project_mail ADD ASSIGNED_ISSUE tinyint(1) default NULL AFTER SUMMARY;
ALTER TABLE project_mail ADD CREATED_ISSUE tinyint(1) default NULL AFTER SUMMARY;

CREATE TABLE disk_usage (
  PROJECT_ID int(11) NOT NULL default '0',
  TYPE int(11) NOT NULL,
  AMOUNT bigint(20) NOT NULL default '0',
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY (PROJECT_ID,TYPE),
  CONSTRAINT FK_disk_usage_PROJECT_ID FOREIGN KEY (PROJECT_ID) REFERENCES project (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE shared_file (
  ID int(11) NOT NULL auto_increment,
  PROJECT_ID int(11) NOT NULL default '0',
  DIR text NOT NULL,
  NAME text NOT NULL,
  SIZE bigint(20) default NULL,
  TYPE int(11) NOT NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (ID),
  CONSTRAINT FK_shared_file_PROJECT_ID FOREIGN KEY (PROJECT_ID) REFERENCES project (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE subversion (
  ID int(11) NOT NULL auto_increment,
  PROJECT_ID int(11) NOT NULL default '0',
  TYPE SMALLINT NOT NULL,
  URL text default NULL,
  SVN_USER text default NULL,
  SVN_PASSWORD text default NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (ID),
  UNIQUE KEY UQ_PROJECT_ID (PROJECT_ID),
  CONSTRAINT FK_subversion_PROJECT_ID FOREIGN KEY (PROJECT_ID) REFERENCES project (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE issue_shared_file_link (
  ISSUE_ID int(11) NOT NULL default '0',
  SHARED_FILE_ID int(11) NOT NULL default '0',
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime default NULL,
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (ISSUE_ID,SHARED_FILE_ID),
  CONSTRAINT FK_issue_shared_file_link_ISSUE_ID FOREIGN KEY (ISSUE_ID) REFERENCES issue (ID) ON DELETE CASCADE,
  CONSTRAINT FK_issue_shared_file_link_SHARED_FILE_ID FOREIGN KEY (SHARED_FILE_ID) REFERENCES shared_file (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE page_shared_file_link (
  PAGE_ID int(11) NOT NULL default '0',
  SHARED_FILE_ID int(11) NOT NULL default '0',
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime default NULL,
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (PAGE_ID,SHARED_FILE_ID),
  CONSTRAINT FK_page_shared_file_link_PAGE_ID FOREIGN KEY (PAGE_ID) REFERENCES page (ID) ON DELETE CASCADE,
  CONSTRAINT FK_page_shared_file_link_SHARED_FILE_ID FOREIGN KEY (SHARED_FILE_ID) REFERENCES shared_file (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


INSERT INTO default_issue_type VALUES (1,'バグ',0,'#990000',NULL,'2005-04-19 03:23:59',NULL,'2005-04-18 17:31:06'),(2,'タスク',1,'#7ea800',NULL,'2005-05-15 00:47:12',NULL,'2007-09-24 15:31:31'),(3,'要望',2,'#ff9200',NULL,'2005-05-15 00:49:53',NULL,'2007-09-24 15:31:31'),(4,'その他',3,'#2779ca',NULL,'2005-05-15 00:49:53',NULL,'2007-09-24 15:31:31');


insert into issue_type (
select 
  project.id * 4 + default_issue_type.id as id,
  project.id as project_id,
  default_issue_type.name, 
  default_issue_type.display_order,
  default_issue_type.color,
  default_issue_type.created_user_id,
  default_issue_type.created,
  default_issue_type.updated_user_id,
  default_issue_type.updated
from 
  project, default_issue_type
order by
  id
);

update issue set issue_type_id=project_id * 4 + issue_type_id, UPDATED = UPDATED;

INSERT INTO dashboard (USER_ID, SHOW_CREATED_ISSUE, CREATED, UPDATED) SELECT id, false, now(), now() FROM users;

insert into issue_component(ISSUE_ID, LINK_ID) select ID, COMPONENT_ID from issue where COMPONENT_ID is not null;
insert into issue_affectedversion(ISSUE_ID, LINK_ID) select ID, AFFECTED_VERSION_ID from issue where AFFECTED_VERSION_ID is not null;
insert into issue_fixedversion(ISSUE_ID, LINK_ID) select ID,  FIXED_VERSION_ID from issue where FIXED_VERSION_ID is not null;

update space set NEED_INDEXING='1';
