ALTER TABLE version MODIFY NAME varchar(50) NOT NULL;
ALTER TABLE project MODIFY PROJECT_KEY varchar(50) NOT NULL;
ALTER TABLE information MODIFY FROM_DATE datetime NOT NULL;
ALTER TABLE information MODIFY TO_DATE datetime NOT NULL;
ALTER TABLE information MODIFY CREATED datetime NOT NULL;

CREATE INDEX `IX_CREATED_USER_ID` ON issue (CREATED_USER_ID);
CREATE INDEX `IX_CREATED_USER_ID` ON comment (CREATED_USER_ID);
CREATE INDEX `IX_CREATED` ON comment (CREATED);

ALTER TABLE space ADD LANG char(2) NOT NULL default 'en' after BASE_URL;
ALTER TABLE space ADD TIMEZONE varchar(50) NOT NULL default 'GMT' after LANG;
ALTER TABLE users ADD LANG char(2) NULL after ICON;
ALTER TABLE users ADD TIMEZONE varchar(50) NULL after LANG;
UPDATE space SET LANG='ja', TIMEZONE='Asia/Tokyo', created = created, updated = updated;

ALTER TABLE default_issue_type ADD LANG char(2) NOT NULL default 'ja' after ID;
INSERT INTO default_issue_type VALUES 
(5,'en','Bug',0,'#990000',NULL,'2005-04-19 03:23:59',NULL,'2005-04-18 17:31:06'),
(6,'en','Task',1,'#7ea800',NULL,'2005-05-15 00:47:12',NULL,'2007-09-24 15:31:31'),
(7,'en','Request',2,'#ff9200',NULL,'2005-05-15 00:49:53',NULL,'2007-09-24 15:31:31'),
(8,'en','Other',3,'#2779ca',NULL,'2005-05-15 00:49:53',NULL,'2007-09-24 15:31:31');

ALTER TABLE information ADD LANG char(2) NOT NULL default 'ja' after INFO_KEY;

ALTER TABLE comment ADD PROJECT_ID int(11) AFTER ISSUE_ID;
UPDATE comment SET PROJECT_ID = (SELECT project_id FROM issue WHERE issue.id = issue_id), UPDATED = UPDATED;
ALTER TABLE comment CHANGE PROJECT_ID PROJECT_ID int(11) NOT NULL;
CREATE INDEX IX_PROJECT_ID_UPDATED ON comment (PROJECT_ID, UPDATED);

ALTER TABLE space CHANGE CREATED CREATED datetime NOT NULL;
ALTER TABLE space CHANGE UPDATED UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP;

ALTER TABLE issue ADD START_DATE datetime AFTER ASSIGNER_ID;
CREATE INDEX IX_START_DATE ON issue (START_DATE);

ALTER TABLE page MODIFY CONTENT MEDIUMTEXT DEFAULT NULL;

ALTER TABLE project ADD USE_GANTT tinyint(1) AFTER ARCHIVED;

ALTER TABLE licence ADD GANTT tinyint(1) DEFAULT 0 AFTER STORAGE_LIMIT;
UPDATE licence SET GANTT = 1 WHERE LICENCE_TYPE_ID >= 40 OR SPACE_ID = 11;
ALTER TABLE licence_type ADD GANTT tinyint(1) DEFAULT 0 AFTER STORAGE_LIMIT;
UPDATE licence_type SET GANTT = 1 WHERE ID >= 40;
ALTER TABLE licence_changelog ADD GANTT tinyint(1) DEFAULT 0 AFTER STORAGE_LIMIT;

ALTER TABLE issue ADD ESTIMATED_HOURS FLOAT DEFAULT NULL AFTER LIMIT_DATE;
ALTER TABLE issue ADD ACTUAL_HOURS FLOAT DEFAULT NULL AFTER ESTIMATED_HOURS;
ALTER TABLE version ADD START_DATE DATETIME DEFAULT NULL AFTER DESCRIPTION;
ALTER TABLE project ADD USE_BURNDOWN tinyint(1) AFTER USE_GANTT;
ALTER TABLE licence ADD BURNDOWN tinyint(1) DEFAULT 0 AFTER GANTT;
UPDATE licence SET BURNDOWN = 1 WHERE LICENCE_TYPE_ID >= 40 OR SPACE_ID = 11;
ALTER TABLE licence_type ADD BURNDOWN tinyint(1) DEFAULT 0 AFTER GANTT;
UPDATE licence_type SET BURNDOWN = 1 WHERE ID >= 40;
ALTER TABLE licence_changelog ADD BURNDOWN tinyint(1) DEFAULT 0 AFTER GANTT;

CREATE TABLE `space_field` (
  `SPACE_ID` INT(11) NOT NULL,
  `FIELD_KEY` VARCHAR(255) NOT NULL,
  `VALUE` TEXT,
  `CREATED_USER_ID` INT(11),
  `CREATED` DATETIME,
  `UPDATED_USER_ID` INT(11),
  `UPDATED` TIMESTAMP(19) DEFAULT CURRENT_TIMESTAMP,
  INDEX (`SPACE_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE INDEX `IX_PROJECT_ID_UPDATED` ON shared_file (`PROJECT_ID`, `UPDATED` DESC);
CREATE INDEX `IX_PROJECT_ID_UPDATED` ON page (`PROJECT_ID`, `UPDATED` DESC);
CREATE INDEX `IX_PROJECT_ID_UPDATED` ON issue (`PROJECT_ID`, `UPDATED` DESC);

UPDATE issue SET COMPONENT_ID = NULL, created = created, updated = updated WHERE component_id IS NOT NULL AND id NOT IN (SELECT issue_id FROM issue_component);
UPDATE issue SET affected_version_id = NULL, created = created, updated = updated WHERE affected_version_id IS NOT NULL AND id NOT IN (SELECT issue_id FROM issue_affectedversion);
UPDATE issue SET fixed_version_id = NULL, created = created, updated = updated WHERE fixed_version_id IS NOT NULL AND id NOT IN (SELECT issue_id FROM issue_fixedversion);

UPDATE space SET NEED_INDEXING='1';
