---
--- Backlog Package 1.4.X
---

--
-- 20080728
--
ALTER TABLE version ALTER COLUMN NAME TYPE varchar(50);
ALTER TABLE project ALTER COLUMN PROJECT_KEY TYPE varchar(50);

CREATE INDEX "IX_issue_CREATED_USER_ID" ON issue (CREATED_USER_ID);
CREATE INDEX "IX_comment_CREATED_USER_ID" ON comment (CREATED_USER_ID);
CREATE INDEX "IX_comment_CREATED" ON comment (CREATED);

ALTER TABLE space ADD LANG char(2) NOT NULL default 'en';
ALTER TABLE space ADD TIMEZONE varchar(50) NOT NULL default 'GMT';
ALTER TABLE users ADD LANG char(2) NULL;
ALTER TABLE users ADD TIMEZONE varchar(50) NULL;
UPDATE space SET LANG='ja', TIMEZONE='Asia/Tokyo', created = created, updated = updated;

ALTER TABLE default_issue_type ADD LANG char(2) NOT NULL default 'ja';
INSERT INTO default_issue_type (id,lang,name,display_order,color,created_user_id,created,updated_user_id,updated) VALUES (5,'en','Bug',0,'#990000',NULL,'2005-04-19 03:23:59',NULL,'2005-04-18 17:31:06');
INSERT INTO default_issue_type (id,lang,name,display_order,color,created_user_id,created,updated_user_id,updated) VALUES (6,'en','Task',1,'#7ea800',NULL,'2005-05-15 00:47:12',NULL,'2007-09-24 15:31:31');
INSERT INTO default_issue_type (id,lang,name,display_order,color,created_user_id,created,updated_user_id,updated) VALUES (7,'en','Request',2,'#ff9200',NULL,'2005-05-15 00:49:53',NULL,'2007-09-24 15:31:31');
INSERT INTO default_issue_type (id,lang,name,display_order,color,created_user_id,created,updated_user_id,updated) VALUES (8,'en','Other',3,'#2779ca',NULL,'2005-05-15 00:49:53',NULL,'2007-09-24 15:31:31');

ALTER TABLE information ADD LANG char(2) NOT NULL default 'ja';

--
-- 20080930
--
ALTER TABLE comment ADD PROJECT_ID integer;
UPDATE comment SET PROJECT_ID = (SELECT project_id FROM issue WHERE issue.id = issue_id), UPDATED = UPDATED;
ALTER TABLE comment ALTER PROJECT_ID SET NOT NULL;
CREATE INDEX "IX_comment_PROJECT_ID_UPDATED" ON comment (PROJECT_ID, UPDATED);

--
-- 20081128
--
ALTER TABLE issue ADD START_DATE date;
CREATE INDEX "IX_issue_START_DATE" ON issue (START_DATE);

ALTER TABLE project ADD USE_GANTT boolean;

ALTER TABLE licence ADD GANTT boolean DEFAULT false;
UPDATE licence SET GANTT = true;
ALTER TABLE licence_type ADD GANTT boolean DEFAULT false;
UPDATE licence_type SET GANTT = true WHERE id >= 40;
ALTER TABLE licence_changelog ADD GANTT boolean DEFAULT false;

ALTER TABLE issue ADD ESTIMATED_HOURS real DEFAULT NULL;
ALTER TABLE issue ADD ACTUAL_HOURS real DEFAULT NULL;
ALTER TABLE version ADD START_DATE date DEFAULT NULL;
ALTER TABLE project ADD USE_BURNDOWN boolean;
ALTER TABLE licence ADD BURNDOWN boolean DEFAULT false;
UPDATE licence SET BURNDOWN = true WHERE LICENCE_TYPE_ID >= 40;
ALTER TABLE licence_type ADD BURNDOWN boolean DEFAULT false;
UPDATE licence_type SET BURNDOWN = true WHERE ID >= 40;
ALTER TABLE licence_changelog ADD BURNDOWN boolean DEFAULT false;

CREATE TABLE space_field (
  SPACE_ID integer NOT NULL,
  FIELD_KEY VARCHAR(255) NOT NULL,
  VALUE TEXT,
  CREATED_USER_ID integer default NULL,
  CREATED timestamp NOT NULL default CURRENT_TIMESTAMP,
  UPDATED_USER_ID integer default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP
);
CREATE INDEX "IX_space_field_SPACE_ID" ON "space_field" (SPACE_ID);

--
-- 20090204
--
CREATE INDEX "IX_shared_file_PROJECT_ID_UPDATED" ON shared_file (PROJECT_ID, UPDATED);
CREATE INDEX "IX_page_PROJECT_ID_UPDATED" ON page (PROJECT_ID, UPDATED);

--
-- 20090331
--
CREATE INDEX "IX_issue_PROJECT_ID_UPDATED" ON issue (PROJECT_ID, UPDATED);

UPDATE issue SET component_id = NULL, created = created, updated = updated WHERE component_id IS NOT NULL AND id NOT IN (SELECT issue_id FROM issue_component);
UPDATE issue SET affected_version_id = NULL, created = created, updated = updated WHERE affected_version_id IS NOT NULL AND id NOT IN (SELECT issue_id FROM issue_affectedversion);
UPDATE issue SET fixed_version_id = NULL, created = created, updated = updated WHERE fixed_version_id IS NOT NULL AND id NOT IN (SELECT issue_id FROM issue_fixedversion);

UPDATE space SET NEED_INDEXING='1';
