ALTER TABLE dashboard ADD USE_PRIVATE_ADDRESS tinyint(1) NOT NULL DEFAULT 0 AFTER SHOW_CREATED_ISSUE;
ALTER TABLE dashboard ADD PRIVATE_ADDRESS_KEY VARCHAR(255) AFTER USE_PRIVATE_ADDRESS;
ALTER TABLE dashboard ADD UNIQUE(PRIVATE_ADDRESS_KEY);
CREATE INDEX IX_USE_PRIVATE_ADDRESS_AND_PRIVATE_ADDRESS_KEY ON dashboard (USE_PRIVATE_ADDRESS,PRIVATE_ADDRESS_KEY);
ALTER TABLE dashboard RENAME TO user_setting;

ALTER TABLE licence ADD TRIAL_EXPIRY_DATE datetime default NULL AFTER SUBSCRIBED_ON;
ALTER TABLE licence_changelog ADD TRIAL_EXPIRY_DATE datetime default NULL AFTER SUBSCRIBED_ON;

ALTER TABLE space_contact ADD POST text default NULL AFTER MAIL_ADDRESS;
ALTER TABLE space_contact ADD POSITION text default NULL AFTER POST;
ALTER TABLE space_contact_changelog ADD POST text default NULL AFTER MAIL_ADDRESS;
ALTER TABLE space_contact_changelog ADD POSITION text default NULL AFTER POST;

CREATE TABLE star (
  ID int(11) NOT NULL auto_increment,
  AWARD_ID int(11) default NULL,
  PRESENTER_ID int(11) default NULL,
  PROJECT_ID int(11) default NULL,
  URL varchar(735) NOT NULL default '',
  TITLE varchar(255) NOT NULL default '',
  COMMENT varchar(100) default NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY (ID),
  KEY IX_URL (URL),
  KEY IX_CREATED (CREATED),
  CONSTRAINT FK_star_AWARD_ID FOREIGN KEY (AWARD_ID) REFERENCES users (ID) ON DELETE CASCADE,
  CONSTRAINT FK_star_PRESENTER_ID FOREIGN KEY (PRESENTER_ID) REFERENCES users (ID) ON DELETE CASCADE,
  CONSTRAINT FK_star_PROJECT_ID FOREIGN KEY (PROJECT_ID) REFERENCES project (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE star_notify (
  ID int(11) NOT NULL auto_increment,
  STAR_ID int(11) default NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY (ID),
  CONSTRAINT FK_star_notify_STAR_ID FOREIGN KEY (STAR_ID) REFERENCES star (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE user_profile (
  USER_ID int(11) NOT NULL,
  SEX tinyint(1) default NULL,
  LOCATION text default NULL,
  BIOGRAPHY text default NULL,
  URLS text default NULL,
  CREATED_USER_ID int(11) default NULL,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED_USER_ID int(11) default NULL,
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY (USER_ID),
  CONSTRAINT FK_user_profile_USER_ID FOREIGN KEY (USER_ID) REFERENCES users (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE space MODIFY lang char(5) NOT NULL DEFAULT 'en';
ALTER TABLE users MODIFY lang char(5) DEFAULT NULL;

DELETE FROM project_mail WHERE NOT EXISTS (SELECT * FROM project_user WHERE project_user.user_id = project_mail.user_id AND project_user.project_id = project_mail.project_id);

ALTER TABLE issue MODIFY DESCRIPTION MEDIUMTEXT;

ALTER TABLE user_setting ADD LAST_UPDATED_NUM int(11) AFTER PRIVATE_ADDRESS_KEY;
ALTER TABLE user_setting ADD LAST_UPDATED_DISABLED_TYPES varchar(255) AFTER LAST_UPDATED_NUM;

ALTER TABLE information MODIFY LANG char(5) NOT NULL DEFAULT 'ja';
ALTER TABLE default_issue_type MODIFY LANG char(5) NOT NULL DEFAULT 'ja';

ALTER TABLE autologin_user ADD INDEX IX_CREATED (created);

ALTER TABLE issue ADD INDEX IX_CREATED_USER_ID_PROJECT_ID (created_user_id, project_id);
ALTER TABLE issue ADD INDEX IX_ASSIGNER_ID_PROJECT_ID (assigner_id, project_id);

CREATE TABLE mobilelogin_user (
  ID varchar(255) BINARY NOT NULL,
  USER_ID int(11) NOT NULL default 0,
  CREATED datetime NOT NULL default '0000-00-00 00:00:00',
  UPDATED timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY (ID),
  CONSTRAINT FK_mobilelogin_user_USER_ID FOREIGN KEY (USER_ID) REFERENCES users (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE user_recent_project (
  USER_ID int(11) NOT NULL,
  PROJECT_ID int(11) NOT NULL,
  CREATED datetime NOT NULL,
  PRIMARY KEY (USER_ID,PROJECT_ID),
  CONSTRAINT FK_recent_project_USER_ID FOREIGN KEY (USER_ID) REFERENCES users (ID) ON DELETE CASCADE,
  CONSTRAINT FK_recent_project_PROJECT_ID FOREIGN KEY (PROJECT_ID) REFERENCES project (ID) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

UPDATE space SET NEED_INDEXING='1';
